#line 1 "C:/Users/raj/Desktop/EmbeddedLab_Code/MikroC_PIC/PIC12F683/TRH_Meter/TRH_Meter.c"
#line 18 "C:/Users/raj/Desktop/EmbeddedLab_Code/MikroC_PIC/PIC12F683/TRH_Meter/TRH_Meter.c"
unsigned short TOUT = 0, CheckSum, i;
unsigned short T_Byte1, T_Byte2, RH_Byte1, RH_Byte2;
unsigned short check, brightness=0x0b;
unsigned int counter = 0, TempF, RH, ADC_OP;
unsigned short Brightness_Table[11] = {0, 1, 2, 4, 5, 7, 9, 11, 12, 14, 15};

void SPI_Write_Byte(unsigned short num){
 unsigned short t, Mask, Flag;
  GP2_bit  = 0;
 Mask = 128;
 for (t=0; t<8; t++){
 Flag = num & Mask;
 if(Flag == 0)  GP1_bit  = 0;
 else  GP1_bit  = 1;
  GP2_bit  = 1;
  GP2_bit  = 0;
 Mask = Mask >> 1;
 }
}

void MAX7219_INIT() {

  GP0_bit  = 0;
 SPI_Write_Byte(0x0C);
 SPI_Write_Byte(0x01);
  GP0_bit  = 1;


  GP0_bit  = 0;
 SPI_Write_Byte(0x09);
 SPI_Write_Byte(0b11101110);
  GP0_bit  = 1;


  GP0_bit  = 0;
 SPI_Write_Byte(0x0A);
 SPI_Write_Byte(brightness);
  GP0_bit  = 1;


  GP0_bit  = 0;
 SPI_Write_Byte(0x0B);
 SPI_Write_Byte(0x07);
  GP0_bit  = 1;


  GP0_bit  = 0;
 SPI_Write_Byte(0x0F);
 SPI_Write_Byte(0x01);
  GP0_bit  = 1;

 Delay_ms(1000);

  GP0_bit  = 0;
 SPI_Write_Byte(0x0F);
 SPI_Write_Byte(0x00);
  GP0_bit  = 1;

}

 void Display_Value(unsigned int j, unsigned short k){
  GP0_bit  = 0;
 SPI_Write_Byte(k);
 SPI_Write_Byte((j/100)%10);
  GP0_bit  = 1;

  GP0_bit  = 0;
 SPI_Write_Byte(k-1);
 SPI_Write_Byte(((j/10)%10) | 0x80);
  GP0_bit  = 1;

  GP0_bit  = 0;
 SPI_Write_Byte(k-2);
 SPI_Write_Byte(j%10);
  GP0_bit  = 1;

  GP0_bit  = 0;
 SPI_Write_Byte(k-3);
 if(k == 4) SPI_Write_Byte(0x47);
 if(k == 8) SPI_Write_Byte(0x67);
  GP0_bit  = 1;
 }

void StartSignal(){
  TRISIO5_bit  = 0;
  GP5_bit  = 0;
 Delay_ms(25);
  GP5_bit  = 1;
 Delay_us(30);
  TRISIO5_bit  = 1;

}

unsigned short CheckResponse(){
 TOUT = 0;
 TMR2 = 0;
 T2CON.TMR2ON = 1;
 while(! GP5_bit  && !TOUT);
 if (TOUT) return 0;
 else {
 TMR2 = 0;
 while( GP5_bit  && !TOUT);
 if (TOUT) return 0;
 else {
 T2CON.TMR2ON = 0;
 return 1;
 }
 }
}

unsigned short ReadByte(){
 unsigned short num = 0, t;
  TRISIO5_bit  = 1;
 for (i=0; i<8; i++){
 while(! GP5_bit );
 TMR2 = 0;
 T2CON.TMR2ON = 1;
 while( GP5_bit );
 T2CON.TMR2ON = 0;
 if(TMR2 > 40) num |= 1<<(7-i);
 }
 return num;
}

void interrupt(){
 if(PIR1.TMR2IF){
 TOUT = 1;
 T2CON.TMR2ON = 0;
 PIR1.TMR2IF = 0;
 }
}

void Display_Brightness(){
  GP0_bit  = 0;
 SPI_Write_Byte(0x0A);
 SPI_Write_Byte(brightness);
  GP0_bit  = 1;
}

void main() {
 TRISIO=0b00011000;
 CMCON0 = 0x07;
 ANSEL = 0x08;
 INTCON.GIE = 1;
 INTCON.PEIE = 1;

 PIE1.TMR2IE = 1;
 T2CON = 0;
 PIR1.TMR2IF =0;
 TMR2 = 0;
 MAX7219_INIT();
 do{
 ADC_OP = ADC_Read(3);
 ADC_OP = ADC_OP/100;
 Brightness = Brightness_Table[ADC_OP];
 Display_Brightness();
 StartSignal();
 check = CheckResponse();
 if (!check) {
 TempF = 0;
 RH = 0;
 }
 else{

 RH_Byte1 = ReadByte();
 RH_Byte2 = ReadByte();
 T_Byte1 = ReadByte();
 T_Byte2 = ReadByte();
 CheckSum = ReadByte();

 if (CheckSum == ((RH_Byte1 + RH_Byte2 + T_Byte1 + T_Byte2) & 0xFF))
 {
 TempF = 10*T_Byte1;
 TempF = 9*TempF/5 + 320;
 RH = 10*RH_Byte1;
 }

 else{
 TempF = 0;
 RH = 0;
 }
 }

 Display_Value(TempF, 4);
 Display_Value(RH, 8);
 Delay_ms(500);



 }while(1);
}
